/*                  Part of x2grbl
 *
 *  Copyright Johann Wilhelm <johann.wilhelm@9mal6.de> 2015
 *
 *  see Readme.md for detailed license and usage information!
*/

#ifndef GCODEINTERPRETER_H
#define GCODEINTERPRETER_H

#include <QObject>

#include "gcodeparser.h"
#include "gcodeoutputdevice.h"

class GCodeInterpreter : public QObject
{
    Q_OBJECT
    enum MeasuringUnit {
        MeasuringUnit_mm,
        MeasuringUnit_inch
    };

public:
    GCodeInterpreter(QObject *parent=0);

    bool Run(GCodeOutputDevice &Device, GCodeParser &Parser);
    bool RunAsync(GCodeOutputDevice &Device, GCodeParser &Parser);

protected:
    bool Execute(GCodeOutputDevice &Device, QString Command, int &NextLine);

    bool isRelative;
    MeasuringUnit Unit;

    bool ExecutionInProgress;
    int NextAsyncLineNumber;
};

#endif // GCODEINTERPRETER_H
